package mx.binding
{
   import flash.events.Event;
   import flash.events.IEventDispatcher;
   import mx.core.EventPriority;
   import mx.core.mx_internal;
   
   use namespace mx_internal;
   
   public class FunctionReturnWatcher extends Watcher
   {
      mx_internal static const VERSION:String = "2.0.1.0";
      
      private var functionName:String;
      
      private var _functionGetter:Function;
      
      private var events:Object;
      
      private var document:Object;
      
      private var parameterFunction:Function;
      
      private var parentObj:Object;
      
      public var parentWatcher:Watcher;
      
      public function FunctionReturnWatcher(param1:String, param2:Object, param3:Function, param4:Object)
      {
         super();
         this.functionName = param1;
         this.document = param2;
         this.parameterFunction = param3;
         this.events = param4;
      }
      
      public function set functionGetter(param1:Function) : void
      {
         _functionGetter = param1;
      }
      
      public function eventHandler(param1:Event) : void
      {
         updateFunctionReturn();
         notifyListeners(events[param1.type]);
      }
      
      override public function updateParent(param1:Object) : void
      {
         if(!(param1 is Watcher))
         {
            setupParentObj(param1);
         }
         else if(param1 == parentWatcher)
         {
            setupParentObj(parentWatcher.value);
         }
         updateFunctionReturn();
      }
      
      public function updateFunctionReturn() : void
      {
         wrapUpdate(function():void
         {
            if(_functionGetter != null)
            {
               value = _functionGetter(functionName).apply(parentObj,parameterFunction.apply(document));
            }
            else
            {
               value = parentObj[functionName].apply(parentObj,parameterFunction.apply(document));
            }
            updateChildren();
         });
      }
      
      override protected function shallowClone() : Watcher
      {
         var _loc1_:FunctionReturnWatcher = null;
         _loc1_ = new FunctionReturnWatcher(functionName,document,parameterFunction,events);
         if(_functionGetter != null)
         {
            _loc1_.functionGetter = _functionGetter;
         }
         return _loc1_;
      }
      
      private function setupParentObj(param1:Object) : void
      {
         var _loc2_:IEventDispatcher = null;
         var _loc3_:String = null;
         if(parentObj != null && parentObj is IEventDispatcher && events != null)
         {
            _loc2_ = parentObj as IEventDispatcher;
            for(_loc3_ in events)
            {
               _loc2_.removeEventListener(_loc3_,eventHandler);
            }
         }
         parentObj = param1;
         if(parentObj != null && parentObj is IEventDispatcher && events != null)
         {
            _loc2_ = parentObj as IEventDispatcher;
            for(_loc3_ in events)
            {
               if(_loc3_ != "__NoChangeEvent__")
               {
                  _loc2_.addEventListener(_loc3_,eventHandler,false,EventPriority.BINDING,true);
               }
            }
         }
      }
   }
}

